import traceback

from cpl_core.configuration.configuration_model_abc import ConfigurationModelABC
from cpl_core.console import Console


class ServerSettings(ConfigurationModelABC):

    def __init__(self):
        ConfigurationModelABC.__init__(self)

        self._id: int = 0
        self._message_delete_timer: int = 0
        self._bot_has_no_permission_message: str = ''

    @property
    def id(self) -> int:
        return self._id
    
    @property
    def message_delete_timer(self) -> int:
        return self._message_delete_timer

    @property
    def bot_has_no_permission_message(self) -> str:
        return self._bot_has_no_permission_message

    def from_dict(self, settings: dict):
        try:
            self._id = int(settings['Id'])
            self._message_delete_timer = int(settings['MessageDeleteTimer'])
            self._bot_has_no_permission_message = settings['BotHasNoPermissionMessage']      
        except Exception as e:
            Console.error(f'[ ERROR ] [ {__name__} ]: Reading error in settings')
            Console.error(f'[ EXCEPTION ] [ {__name__} ]: {e} -> {traceback.format_exc()}')
