from abc import ABC, abstractmethod
from typing import Optional

from cpl_query.extension import List
from gismo_data.model.user_joined_server import UserJoinedServer


class UserJoinedServerRepositoryABC(ABC):

    @abstractmethod
    def __init__(self): pass
    
    @abstractmethod
    def get_user_joined_servers(self) -> List[UserJoinedServer]: pass
    
    @abstractmethod
    def get_user_joined_server_by_id(self, id: int) -> UserJoinedServer: pass
    
    @abstractmethod
    def get_user_joined_servers_by_user_id(self, user_id: int) -> list[UserJoinedServer]: pass
    
    @abstractmethod
    def get_active_user_joined_server_by_user_id(self, user_id: int) -> UserJoinedServer: pass
    
    @abstractmethod
    def find_active_user_joined_server_by_user_id(self, user_id: int) -> Optional[UserJoinedServer]: pass
    
    @abstractmethod
    def add_user_joined_server(self, user_joined_server: UserJoinedServer): pass
    
    @abstractmethod
    def update_user_joined_server(self, user_joined_server: UserJoinedServer): pass
    
    @abstractmethod
    def delete_user_joined_server(self, user_joined_server: UserJoinedServer): pass
